package org.apache.mahout.keel.Algorithms.ImbalancedClassification.Ensembles;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.apache.mahout.keel.Dataset.InstanceSet;
import org.apache.mahout.keel.Algorithms.ImbalancedClassification.Ensembles.Preprocess.Basic.Metodo;
import org.apache.mahout.keel.Algorithms.ImbalancedClassification.Ensembles.Preprocess.Instance_Selection.EUSCHCQstat.EUSCHCQstat;


public class EUS {
	parseParameters parameters;
	myDataset train;


	private boolean somethingWrong = false; //to check if everything is correct.

	boolean selected[];

	public EUS(InstanceSet IS, parseParameters parameters, Boolean[][] anteriores, int utilIteraciones) {
		this.parameters = parameters;
		
		/*train = new myDataset();
		try {
			//System.out.println("\nReading the training set: " +	parameters.getTrainingInputFile());
			train.readInstanceSet(IS);
			//this.context.progress();

		}
		catch (IOException e) {
			System.err.println(
					"There was a problem while reading the input data-sets: " +
							e);
			somethingWrong = true;
		}
		*/

		String ISmethod = parameters.getParameter(1);
		// System.out.println("IS method: "+ISmethod);
		Ensemble.ISmethod = ISmethod;
		Ensemble.minorityWindows = Integer.parseInt(parameters.getParameter(2));
		Ensemble.majorityWindows =  Integer.parseInt(parameters.getParameter(3));

		Metodo m = null;          
		
		// Isaac,29/4/2016: avoid writing this file on disk
		String config = Ensemble.createConf(ISmethod.substring(5) + "Conf.txt");
		//m = new EUSCHCQstat(ISmethod.substring(5) + "Conf.txt", IS);
		m = new EUSCHCQstat(config, IS);
		
		// IS.print();
		//if(anteriores.size() >0){
		if(utilIteraciones>0){ // check it has values.
			
			ArrayList<Integer> indexNegatives = new ArrayList<Integer>() ;
			int cont=0;
			
			// cuento cuantas son negatvias, y me quedo con los indices para ir al grano obteniendo la matriz que necesito.
		//	System.out.println("List of PREVIOUSLY selected instnaces INCLUYENDO POSITIVAS: ");

			for(int j=0; j<anteriores[0].length; j++){
			//	System.out.print(IS.getOutputNominalValue(j,0)+ ", ");
				if(IS.getOutputNominalValue(j,0).equals("negative")){
					indexNegatives.add(j);
					cont++;
				}
				/*
					if(anteriores[0][j]){ 
					    System.out.print(j+";");
					}
				*/
			}
			//System.out.println("");
			boolean previous[][] = new boolean[anteriores.length][]; 
			
			//System.out.println("\nList of PREVIOUSLY selected instnaces: ");
			int cont2=0;
			for(int i=0; i<utilIteraciones; i++){
				
				previous[i] = new boolean[cont];
				for(int j=0; j<indexNegatives.size(); j++){
					previous[i][j] = anteriores[i][indexNegatives.get(j)];
					
					if(previous[i][j]){ 
						cont2++;
						//System.out.print(j+";");
					}
				}
				//System.out.println("");
			}
			
			System.out.println("\nSize IS: "+anteriores[0].length+ "; negatives= "+previous[0].length + ", de los cuales seleccionados: "+cont2);
			
			// System.exit(1);
				
			System.out.println("previous size: "+previous.length+", "+cont);
			((EUSCHCQstat)m).setAnteriores(previous); 
		}else{		
			((EUSCHCQstat)m).setAnteriores(new boolean[1][]); // Para que no de null
    	}
		m.runAlgorithm();
		//selected = ((EUSCHCQstat)m).getBest(); // Si hacemos EUS de la mayoritaria serᡥl chromosoma solo para eso y si es de las dos clases, serᡤe las dos clases
		
		int selectedIndex[]=((EUSCHCQstat)m).getSelected(); //-> devuelve los ices de las seleccionadas
		
		selected = new boolean[IS.getNumInstances()];
		Arrays.fill(selected, false);
		
		//System.out.println("List of selected intances in this: ");
		for (int i = 0; i < selectedIndex.length; i++){
			selected[selectedIndex[i]] = true;
			
			//System.out.print(selectedIndex[i]+"-");
		}
		System.out.println("Seleccionadas = " + selectedIndex.length + " de " + selected.length);

		
		// CLEANING:
		IS=null;
		m=null;
	}
        
    public EUS(InstanceSet IS, parseParameters parameters, int nNegativeInstancesPermap, boolean [][] anteriores) {
		this.parameters = parameters;
		train = new myDataset();
		try {
			//System.out.println("\nReading the training set: " +	parameters.getTrainingInputFile());
			train.readInstanceSet(IS);
			//this.context.progress();

		}
		catch (IOException e) {
			System.err.println(
					"There was a problem while reading the input data-sets: " +
							e);
			somethingWrong = true;
		}

		String ISmethod = parameters.getParameter(1);
		// System.out.println("IS method: "+ISmethod);
		Ensemble.ISmethod = ISmethod;
		Ensemble.minorityWindows = Integer.parseInt(parameters.getParameter(2));
		Ensemble.majorityWindows =  Integer.parseInt(parameters.getParameter(3));

		Metodo m = null;          
		
		// Isaac,29/4/2016: avoid writing this file on disk
		String config = Ensemble.createConf(ISmethod.substring(5) + "Conf.txt");
		//m = new EUSCHCQstat(ISmethod.substring(5) + "Conf.txt", IS);
		m = new EUSCHCQstat(config, IS);
		((EUSCHCQstat)m).setNumberOfNegativeInstancesToBeSelected(nNegativeInstancesPermap); // negative instances to be selected
                
		// IS.print();
		
		if(anteriores!=null){
			((EUSCHCQstat)m).setAnteriores(anteriores); 
		}else{		
			((EUSCHCQstat)m).setAnteriores(new boolean[1][]); // Para que no de null
    	}
		
		m.runAlgorithm();
		//selected = ((EUSCHCQstat)m).getBest(); // Si hacemos EUS de la mayoritaria serᡥl chromosoma solo para eso y si es de las dos clases, serᡤe las dos clases
		
                selected = ((EUSCHCQstat)m).getBest().clone();
                int nSelected = 0;
                for (int i = 0; i < selected.length; i++){
                    if (selected[i])
                        nSelected++;
                }
		
		System.out.println("Seleccionadas = " + nSelected + " de " + selected.length);

	}

	public boolean[] getSelection(){
		return selected;
	}



}

/*
 * 		// IS.print();
		if(anteriores.size() >0){
			
			ArrayList<Integer> indexNegatives = new ArrayList<Integer>() ;
			int cont=0;
			
			// cuento cuantas son negatvias, y me quedo con los indices para ir al grano obteniendo la matriz que necesito.
			System.out.println("List of PREVIOUSLY selected instnaces INCLUYENDO POSITIVAS: ");

			for(int j=0; j<anteriores.get(0).length; j++){
			//	System.out.print(IS.getOutputNominalValue(j,0)+ ", ");
				if(IS.getOutputNominalValue(j,0).equals("negative")){
					indexNegatives.add(j);
					cont++;
				}
				
				if(anteriores.get(0)[j]){ 
				    System.out.print(j+";");
				}
			}
			//System.out.println("");
			boolean previous[][] = new boolean[anteriores.size()][cont]; tamaño esta mal... tiene que ser NUMITERACIONES
			
			System.out.println("\nList of PREVIOUSLY selected instnaces: ");
			int cont2=0;
			for(int i=0; i<anteriores.size(); i++){
				for(int j=0; j<indexNegatives.size(); j++){
					previous[i][j] = anteriores.get(i)[indexNegatives.get(j)];
					
					if(previous[i][j]){ 
						cont2++;
						System.out.print(j+";");
					}
				}
			}
			
			System.out.println("\nSize IS: "+anteriores.get(0).length+ "; negatives= "+previous[0].length + ", de los cuales seleccionados: "+cont2);
			
			// System.exit(1);
*/